"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _EmbeddedConnector_db, _EmbeddedConnector_session;
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmbeddedConnector = void 0;
const RTDB = require("@rtdb2/core");
const utils_1 = require("@hibas123/utils");
class EmbeddedConnector {
    constructor(path) {
        _EmbeddedConnector_db.set(this, void 0);
        _EmbeddedConnector_session.set(this, void 0);
        this.snapshots = new Map();
        this.offline = new utils_1.AwaitStore(false);
        __classPrivateFieldSet(this, _EmbeddedConnector_db, new RTDB.Database(path), "f");
        __classPrivateFieldSet(this, _EmbeddedConnector_session, new RTDB.Session("session"), "f");
        __classPrivateFieldGet(this, _EmbeddedConnector_session, "f").root = true; // root is always true on the local session
    }
    async queryRequest(query, id, ns) {
        if (Array.isArray(query)) {
            return __classPrivateFieldGet(this, _EmbeddedConnector_db, "f").run(query, __classPrivateFieldGet(this, _EmbeddedConnector_session, "f"));
        }
        else {
            if (query.type === "snapshot") {
                return (await __classPrivateFieldGet(this, _EmbeddedConnector_db, "f").snapshot(query, __classPrivateFieldGet(this, _EmbeddedConnector_session, "f"), (change) => {
                    this.snapshots.get(id).receivedData(change);
                }));
            }
            else if (query.type === "unsubscribe") {
                return __classPrivateFieldGet(this, _EmbeddedConnector_db, "f").unsubscribe(id, __classPrivateFieldGet(this, _EmbeddedConnector_session, "f"));
            }
            else {
                return __classPrivateFieldGet(this, _EmbeddedConnector_db, "f").run([query], __classPrivateFieldGet(this, _EmbeddedConnector_session, "f"));
            }
        }
    }
    async close() {
        await __classPrivateFieldGet(this, _EmbeddedConnector_db, "f").stop();
    }
}
exports.EmbeddedConnector = EmbeddedConnector;
_EmbeddedConnector_db = new WeakMap(), _EmbeddedConnector_session = new WeakMap();
//# sourceMappingURL=index.js.map